/* SPDX-License-Identifier: (GPL-2.0+ OR MIT) */
/*
 * Copyright (C) 2020 Telechips Inc.
 */
#ifndef DT_BINDINGS_PMAP_TCC805X_LINUX_IVI_DISPLAY_H
#define DT_BINDINGS_PMAP_TCC805X_LINUX_IVI_DISPLAY_H

//***************************** DISPLAY ******************************/
#define PRIMARY_FRAMEBUFFER_WIDTH	1920
#define PRIMARY_FRAMEBUFFER_HEIGHT	720
#define SECONDARY_FRAMEBUFFER_WIDTH	0
#define SECONDARY_FRAMEBUFFER_HEIGHT	0
#define TERTIARY_FRAMEBUFFER_WIDTH	0
#define TERTIARY_FRAMEBUFFER_HEIGHT	0
#define QUATERNARY_FRAMEBUFFER_WIDTH	0
#define QUATERNARY_FRAMEBUFFER_HEIGHT	0
#define SUPPORT_DISPLAY_MAX_WIDTH	PRIMARY_FRAMEBUFFER_WIDTH
#define SUPPORT_DISPLAY_MAX_HEIGHT	PRIMARY_FRAMEBUFFER_HEIGHT
#define SUPPORT_VIQE_MAX_WIDTH		1920
#define SUPPORT_VIQE_MAX_HEIGHT		1088
#define SUPPORT_VIDEO_MAX_WIDTH		4096
#define SUPPORT_VIDEO_MAX_HEIGHT	2160
#define FRAMES_OVERLAY_ROT		0

//****************************** Camera ******************************/
#define CAMERA_INPUT_WIDTH		1280
#define CAMERA_INPUT_HEIGHT		720
#define CAMERA_OUTPUT_WIDTH		1920
#define CAMERA_OUTPUT_HEIGHT		1080

#define FRAMES_CAMERA_VIQE		0
#define FRAMES_CAMERA_PREVIEW0		0
#define FRAMES_CAMERA_PREVIEW1		0
#define FRAMES_CAMERA_PREVIEW2		0
#define FRAMES_CAMERA_PREVIEW3		0
#define FRAMES_CAMERA_PREVIEW4		0
#define FRAMES_CAMERA_PREVIEW5		0
#define FRAMES_CAMERA_PREVIEW6		0
#define FRAMES_CAMERA_PREVIEW7		0
#define FRAMES_CAMERA_PGL		0


//****************************** Calculation ******************************/
#undef SZ_1MB
#define SZ_1MB				(1024*1024)
#define ARRAY_16MBYTE(x)		((((x) + ((16*SZ_1MB)-1)) >> 24) << 24)
#define ARRAY_MBYTE(x)			((((x) + (SZ_1MB-1)) >> 20) << 20)
#define ARRAY_256KBYTE(x)		((((x) + ((SZ_1MB/4)-1)) >> 18) << 18)

#define PMAP_SIZE_FB_VIDEO		\
	ARRAY_MBYTE(PRIMARY_FRAMEBUFFER_WIDTH * \
		PRIMARY_FRAMEBUFFER_HEIGHT * 4 * 3)
#define PMAP_SIZE_FB1_VIDEO		\
	ARRAY_MBYTE(SECONDARY_FRAMEBUFFER_WIDTH * \
		SECONDARY_FRAMEBUFFER_HEIGHT * 4 * 3)
#define PMAP_SIZE_FB2_VIDEO		\
	ARRAY_MBYTE(TERTIARY_FRAMEBUFFER_WIDTH * \
		TERTIARY_FRAMEBUFFER_HEIGHT * 4 * 3)
#define PMAP_SIZE_FB3_VIDEO		\
	ARRAY_MBYTE(QUATERNARY_FRAMEBUFFER_WIDTH * \
		QUATERNARY_FRAMEBUFFER_HEIGHT * 4 * 3)

#define PMAP_SIZE_OSD			\
	ARRAY_MBYTE(0)	// 0x01d00000 = 2560 * 1440 * 4 * 2

#define PMAP_SIZE_OVERLAY		\
	ARRAY_MBYTE(SUPPORT_DISPLAY_MAX_WIDTH * SUPPORT_DISPLAY_MAX_HEIGHT * 2 \
		* 3)
#define PMAP_SIZE_OVERLAY1		\
	ARRAY_MBYTE(SUPPORT_DISPLAY_MAX_WIDTH * SUPPORT_DISPLAY_MAX_HEIGHT * 2 \
		* 3)
#define PMAP_SIZE_OVERLAY_ROT		\
	ARRAY_MBYTE(SUPPORT_DISPLAY_MAX_WIDTH * SUPPORT_DISPLAY_MAX_HEIGHT * 4 \
		* FRAMES_OVERLAY_ROT)

#define PMAP_SIZE_V4L2_VOUT0		\
	ARRAY_MBYTE(SUPPORT_DISPLAY_MAX_WIDTH * SUPPORT_DISPLAY_MAX_HEIGHT * 2 \
		* 3)
#define PMAP_SIZE_V4L2_VOUT1		\
	ARRAY_MBYTE(SUPPORT_DISPLAY_MAX_WIDTH * SUPPORT_DISPLAY_MAX_HEIGHT * 2 \
		* 3)

#define PMAP_SIZE_VIQE0			\
	ARRAY_MBYTE((SUPPORT_VIQE_MAX_WIDTH * (SUPPORT_VIQE_MAX_HEIGHT / 2) \
		* 4 * 4 * 3) / 2)
#define PMAP_SIZE_VIQE1			\
	ARRAY_MBYTE((SUPPORT_VIQE_MAX_WIDTH * (SUPPORT_VIQE_MAX_HEIGHT / 2) \
		* 4 * 4 * 3) / 2)

#define PMAP_SIZE_FB_WMIXER		\
	ARRAY_MBYTE((((SUPPORT_VIDEO_MAX_WIDTH * 25 / 10) \
		* SUPPORT_VIDEO_MAX_HEIGHT * 15 / 10) + 0x80000) * 2)

#define PMAP_SIZE_CAMERA_VIQE		\
	ARRAY_MBYTE((CAMERA_INPUT_WIDTH * (CAMERA_INPUT_HEIGHT / 2) * 4 * \
		FRAMES_CAMERA_VIQE) * 3 / 2)
#define PMAP_SIZE_CAMERA_PREVIEW0	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW0)
#define PMAP_SIZE_CAMERA_PREVIEW1	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW1)
#define PMAP_SIZE_CAMERA_PREVIEW2	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW2)
#define PMAP_SIZE_CAMERA_PREVIEW3	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW3)
#define PMAP_SIZE_CAMERA_PREVIEW4	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW4)
#define PMAP_SIZE_CAMERA_PREVIEW5	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW5)
#define PMAP_SIZE_CAMERA_PREVIEW6	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW6)
#define PMAP_SIZE_CAMERA_PREVIEW7	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW7)
#define PMAP_SIZE_CAMERA_PGL		\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PGL)

#endif//DT_BINDINGS_PMAP_TCC805X_LINUX_IVI_DISPLAY_H
